import { Optional, Resource } from "../../common";
import { APIMarkerCategory, StoreMarkerCategory } from "./interfaces";
export declare class MarkerCategory extends Resource {
    /**
     * Name of the category.
     */
    name: string;
    constructor(name: string);
    /**
     * The name of the marker category resource on the API server.
     */
    static get resourceName(): string;
    /**
     * The name of the service containing the marker category resource.
     */
    static get serviceName(): string;
    /**
     * Convert the marker category into a JSON serializable object for the API server.
     */
    serializeAPI(): Optional<APIMarkerCategory, "id">;
    /**
     * Deserialize the data from the API server.
     *
     * @param data The marker category data from the API server.
     */
    deserializeAPI(data: APIMarkerCategory): void;
    /**
     * Serialize the marker category into a format for storing in the Redux store.
     */
    serializeRedux(): StoreMarkerCategory;
    /**
     * Create a marker category from the API server data.
     *
     * @param data Data from the api server.
     *
     * @returns The marker category object.
     */
    static apiFactory(data: APIMarkerCategory): MarkerCategory;
    /**
     * Create a marker category from the Redux store data.
     *
     * @param data Data from the api server.
     *
     * @returns The marker category object.
     */
    static reduxFactory(data: StoreMarkerCategory): MarkerCategory;
}
